      MODULE DIAGNOSTIC

      USE vast_kind_param
      USE opt
      USE slat_dat_M

      IMPLICIT NONE
      REAL(DOUBLE) :: DOF

      CONTAINS

      SUBROUTINE DOFS( M, N, NLD, NLEV )

      INTEGER, INTENT(IN)                :: N, M, NLD, NLEV
      INTEGER                            :: I, J
      !INTEGER                            :: INFO      
      !REAL(DOUBLE), DIMENSION(NLEV)      :: WR, WI
      !REAL(DOUBLE), DIMENSION(4*NLEV)    :: WORK
      REAL(DOUBLE), DIMENSION(N,N)       :: A, SM, IDEN
      REAL(DOUBLE), DIMENSION(N,M)       :: NM, G
      !REAL(DOUBLE), DIMENSION(NLEV,NLEV) :: H, Q
      
!  --- CALCULATE AVERAGING KERNEL NxN MATRIX
!  --- KSK is an nmax*nmax array
      !print *, m, nld, nlev
      !print *, N, 'N'
      CALL MULT( SHAT(:N,:N), KSK, A, N, N, N)

!  --- CALCULATE TRACE OF KERNEL
      DOF = 0.D0
      DO I = 1, NLEV
         DOF = DOF + A(I+NLD,I+NLD)
      END DO
      !PRINT *, 'DOF : ', DOF

!  --- CONVERT TO VMR
      !DO I=1, NLEV
      !  DO J=1, NLEV
      !     !A(I=NLD,J+NLD) = A(I+NLD,J+NLD) * X(1,I) / X(1,J) ! * 1.0D12
      !     DOF = DOF + A(I+NLD,I+NLD)
      !ENDDO
      !ENDDO

      OPEN( 81, FILE='AK.out' )
      WRITE(81,*) NLEV
      DO I=1,NLEV
          WRITE(81,'(255ES26.18)') ( A(I+NLD,J+NLD), J=1, NLEV )
      ENDDO
      CLOSE( 81 )

!  --- CALCULATE MEASUREMENT ERROR : Se IS DIAGONAL, BUT FIRST GAIN
      G(:N,:M) = MATMUL( SHAT(:N,:N), KS(:N,:M) )
      CALL MULTDIAG( G(:N,:M), SE, NM, N, M )
      SM(:N,:N) = MATMUL( NM(:N,:M), TRANSPOSE( G(:N,:M) ))

      OPEN( 81, FILE='SM.out' )
      WRITE(81,*) NLEV
      DO I=1,NLEV
          WRITE(81,'(255ES26.18)') ( SM(I+NLD,J+NLD), J=1, NLEV )
      ENDDO
      CLOSE( 81 )

!  --- CALCULATE SMOOTHING ERROR
!  --- FILL DIAGONAL ELEMENTS OF IDEN, CREATE IDENTITY MATRIX
      IDEN = 0.0D0
      FORALL( I=1 : N ) IDEN(I,I) = 1.D0

      SM = MATMUL( (A-IDEN), SA(:N,:N) )      
      SM = MATMUL( SM, TRANSPOSE( A-IDEN ))

      OPEN( 81, FILE='SS.out' )
      WRITE(81,*) NLEV
      DO I=1,NLEV
          WRITE(81,'(255ES26.18)') ( SM(I+NLD,J+NLD), J=1, NLEV )
      ENDDO
      CLOSE( 81 )

!  --- AK - SMOOTH
      OPEN( 81, FILE='A-S.out' )
      WRITE(81,*) NLEV
      DO I=1,NLEV
          WRITE(81,'(255ES26.18)') ( A(I+NLD,J+NLD)-SM(I+NLD,J+NLD), J=1, NLEV )
      ENDDO
      CLOSE( 81 )

!  --- EIGENVALUE DECOMPOSITION
!      H = A(NLD+1:NLEV,NLD+1:NLEV)
!      CALL DGEEV('N','V',NLEV, H, NLEV, WR, WI, 0, 1, Q, NLEV, WORK, 4*NLEV, INFO)
      !PRINT *, 'INFO :', INFO

!  --- EIGENVALUES OF AK
!      OPEN( 81, FILE='AEIGEN.out' )
!      WRITE(81,*) NLEV, 'first 2 rows are real & imag eigenvalues'    
!      WRITE(81,'(255ES26.18)') ( WR(J), J=1, NLEV )   	! REAL E-VALUE
!      WRITE(81,'(255ES26.18)') ( WI(J), J=1, NLEV )      ! IMAGINARY #-VALUE
!      DO I=1,NLEV
!          WRITE(81,'(255ES26.18)') ( Q(I,J), J=1, NLEV )
!      ENDDO
!      CLOSE( 81 )
      
      END SUBROUTINE DOFS

      END MODULE DIAGNOSTIC