      SUBROUTINE FILSE(SED, NFIT, SNR) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param
      USE params_M 
      USE tfiles_dat_M 
      USE wwv_dat_M 
!...Translated by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
!...Switches: -yf12               
! fills Sed vector (variances of measurements)
! uses default s/n unless a different value is specified
! for a given wavenumber interval
!  maxsnr=maximum number of alternate S/N values
!  mmax=maximum number of spectral data points
 
      IMPLICIT NONE
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      INTEGER :: NFIT 
      REAL(DOUBLE) :: SNR 
      REAL(DOUBLE) :: SED(NFIT) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      INTEGER :: NSTNR, I, J 
      REAL(DOUBLE), DIMENSION(MAXSNR) :: WWV0, WWV1, GSTNR 
      REAL(DOUBLE), DIMENSION(MMAX) :: STNR 
!-----------------------------------------------

      READ (13, *) NSTNR 
      DO I = 1, NSTNR 
         READ (13, *) WWV0(I), WWV1(I), GSTNR(I) 
         !WRITE (*, *) WWV0(I), WWV1(I), GSTNR(I) 
      END DO 
      STNR(:NFIT) = SNR 
      J = 0 
   10 CONTINUE 
      J = J + 1 
      DO I = 1, NSTNR 
         IF (WWV(J)<WWV0(I) .OR. WWV(J)>WWV1(I)) CYCLE  
         STNR(J) = GSTNR(I) 
         IF (J < NFIT) GO TO 10 
      END DO 
      IF (J < NFIT) GO TO 10 
      SED = 1.D0/(STNR(:NFIT)*STNR(:NFIT)) 
!     ... OUTPUT_SEFILE flag set in params.inc.
      IF (OUTPUT_SEFILE) THEN 
         OPEN(67, FILE=TFIL67, STATUS='replace', POSITION='asis') 
         WRITE (67, *) NFIT 
         WRITE (67, *) (SED(I),I=1,NFIT) 
         CLOSE(67) 
      ENDIF 
      RETURN  
      END SUBROUTINE FILSE 
