      SUBROUTINE FM(XN, YN, KN, NFIT, NVAR, KFLG, ITER, Tflg, GASOUTTYPE) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param
      USE params_M 
      USE jmix_dat_M
      USE slat_dat_M
      USE zfft_dat_M
      USE bands_dat_M
      USE trans_dat_M 
      USE spec_dat_M 
      USE tfiles_dat_M 
      USE molec_dat_M 
      USE solar
!...Translated by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
!...Switches: -yf12               
 
      IMPLICIT NONE
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      INTEGER :: NFIT !, m - columns - 1 spectrum
      INTEGER :: NVAR !, n - rows    - for each fit parameter
      INTEGER :: ITER 
      INTEGER :: GASOUTTYPE
      LOGICAL :: KFLG 
      LOGICAL :: Tflg 
      REAL(DOUBLE) :: XN(NVAR) 
      REAL(DOUBLE) :: YN(NFIT) 
  !    REAL(DOUBLE) :: KN(NFIT*NVAR) 
      REAL(DOUBLE) :: KN(NFIT,NVAR) 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      CHARACTER :: GASFNAME*(IFLNMSZ)
      CHARACTER :: TITLE*(80)
      INTEGER :: iii
      INTEGER :: IFCOSAVE
      INTEGER :: NVAR1, KFIT, KZERO, KPHASE, JATMOS, IPARM, I, NCOUNT, &
         KK, MXONE, IBAND, N, JSCAN, MONONE, N1, N2, N3, J, MSHIFT, NS, NR, &
         ns1, ns2 
      REAL(DOUBLE), DIMENSION(3) :: B 
      REAL(DOUBLE), DIMENSION(NMAX) :: PARM 
      REAL(DOUBLE), DIMENSION(MMAX) :: YC 
      REAL(DOUBLE), DIMENSION(NFIT) :: AMP_Y 
      REAL(DOUBLE) :: TEMPP 
      REAL(DOUBLE), DIMENSION(NFIT) :: WAVE_X 
      REAL(DOUBLE) :: DEL, SUMSQ, WSCALE, DWAVE, DSHIFT, FRACS, PHI, SMM, YS, &
         BKGND, YCAVE, FX !, STDEV 
      COMPLEX(DBLE_COMPLEX) :: TCALL, TCALH, TCALI 
!-----------------------------------------------
!   E x t e r n a l   F u n c t i o n s
!-----------------------------------------------
      REAL(DOUBLE) , EXTERNAL :: FIT_CHANNEL_PARMS 
!-----------------------------------------------
!
! Note: lines end with PWJ are revised by Wujian Peng in July,2002  !pwj
! KFlg signals whether to calculate weighting functions K - BJC 12/96
!
!  --- PARAMETER INCREMENT FOR PARTIALS
 
      DATA DEL/0.1D-05/  
      COMPLEX(DBLE_COMPLEX), DIMENSION(:), ALLOCATABLE :: TCONVSAV      
      !REAL(DOUBLE), DIMENSION(:), ALLOCATABLE :: TCONVSAV 
      INTEGER :: NAERR
! -----------------------------------------------------------
!     COMPUTES MONOCHROMATIC SPECTRUM, CONVOLVES WITH INSTRUMENTAL
!     PROFILE, AND FINDS OBSERVED MINUS CALCULATED AMPLITUDES
!     AT ALL POINTS -
!     compute new spectrum (iparm=1) with updated XN
!     then compute KN (NVAR x NFIT) for next iteration
!     outer loop - nvar  inner loop nfit
! -----------------------------------------------------------
      Tflg=.false.

      IF (KFLG) THEN 
         NVAR1 = NVAR + 1 
      ELSE 
         NVAR1 = 1 
      ENDIF 
 
      IF (OUTPUT_CHANNEL_FILES) THEN            !for_channel_value_files
         IF (ITER == 1) OPEN(30, FILE=TFIL30, ERR=2000, POSITION='asis') 
         IF (ITER == 2) OPEN(40, FILE=TFIL40, ERR=2010, POSITION='asis') 
      ENDIF 
 
      PARAM: DO ICOUNT = 1, NVAR1 
         KFIT = 0 
         KZERO = 0 
         KPHASE = 0 
         JATMOS = 0 
         SUMSQ = 0.D0 
         IPARM = ICOUNT - ((ICOUNT - 1)/NVAR1)*NVAR1
          
! --- RESET PARM EVEN AS WE LOOP THROUGH THEM
         PARM(:NVAR) = XN 
        
         IF (ICOUNT /= 1) THEN
            PARM(ICOUNT-1) = PARM(ICOUNT-1) + DEL 
         ENDIF
         
         NCOUNT = NBKFIT + NSHIFT + NZERO 
 
!  --- UPDATE EFFECTIVE APODIZATION
         IF (NEAPRT /= 0) THEN 
            IF (NEAPRT > 0) THEN 
               EAPF(:NEAPRT) = EAPF0(:NEAPRT)*PARM(NCOUNT+1:NEAPRT+NCOUNT) 
               NCOUNT = NEAPRT + NCOUNT 
            ENDIF 
         ENDIF 
         IF (NEPHSRT /= 0) THEN 
            IF (NEPHSRT > 0) THEN 
               EPHSF(:NEPHSRT) = EPHSF0(:NEPHSRT)*PARM(NCOUNT+1:NEPHSRT+NCOUNT) 
               NCOUNT = NEPHSRT + NCOUNT 
            ENDIF 
         ENDIF 

!  --- UPDATE SOLAR CO PARAMETERS
 
         IF (IFCO /= 0) THEN 
            DO I = 1, 5 
               IF (ICFIX(I) /= 0) THEN 
                  NCOUNT = NCOUNT + 1 
                  CPARM(I) = PARM(NCOUNT)*CIPARM(I) 
               ENDIF 
            END DO 
         ENDIF 
         
!  --- UPDATE DIFFERENTIAL SHIFT
         IF (NDIFF /= 0) THEN 
            IF (NDIFF > 0) THEN 
               ISHIFT(:NDIFF) = NINT(PARM(NCOUNT+1:NDIFF+NCOUNT)/.6D-06)
               NCOUNT = NDIFF + NCOUNT 
            ENDIF 
         ENDIF 
         
!  ---  UPDATE NCOUNT INDEX TO INCLUDE PHASE ERROR PARAMETERS
         NCOUNT = NCOUNT + NPHASE 
         
!  ---  UPDATE VMRS OF RETRIEVAL GASES
         DO KK = 1, NRET 
            IF (IRTYPE(KK) /= 1) THEN 
            
!  --- RETRIEVING VERTICAL PROFILE
               IF (KMAX > 0) THEN 
                  X(KK,:KMAX) = PARM(NCOUNT+1:KMAX+NCOUNT)*XORG(KK,:KMAX) 
                  NCOUNT = KMAX + NCOUNT 
               ENDIF 
            ELSE 
            
!  --- SCALING VERTICAL DISTRIBUTION
               NCOUNT = NCOUNT + 1 
               X(KK,:KMAX) = PARM(NCOUNT)*XORG(KK,:KMAX) 
            ENDIF 
         END DO 
         
!  --- SKIP OVER UPDATE TO SOLAR CO CALCULATIONS IF NOT REQUIRED
         IF (NSOLAR /= 0) THEN 
            IF (IPARM == 1) GO TO 6 
            IF (IPARM<NSOLAR1 .OR. IPARM>NSOLAR2) GO TO 7 
    6       CONTINUE 
            CALL SOLARFH( 1 ) 
         ENDIF 
                     
!  --- SKIP OVER MONOCHROMATIC CALCULATIONS IF NOT REQUIRED
    7    CONTINUE 
         IF (IPARM == 1) GO TO 8 
         NCOUNT = 1 + NBKFIT + NSHIFT + NZERO + NEAPRT + NSOLAR + NPHASE + &
            NEPHSRT 
         IF (IPARM <= NCOUNT) GO TO 9 
         
!  --- COMPUTE MONOCHROMATIC TRANSMITTANCES
    8    CONTINUE 
         CALL TALL
         
    9    CONTINUE 
         MONONE = 1 
         MXONE = 1 
 
!  --- RETRIEVE CHANNEL PARMS FROM STATE VECTOR-----------------!PWJ
         CALL RETRIEVE_CHANNEL_PARMS (PARM)      !PWJ 

!  --- LOOP OVER BANDPASSES ----------------------------------------
         BAND: DO IBAND = 1, NBAND 
            N = NSCAN(IBAND)  
            IF (N == 0) CYCLE
              
!  --- LOOP OVER SPECTRA ------------------------------------
            SPEC: DO JSCAN = 1, N 
 
!  --- DETERMINE CURRENT BACKGROUND PARAMETERS CORRESPONDING
!  --- TO SPECTRUM AND BANDPASS 
               B(1) = 1.0D0 
               IF (NBACK <= 1) THEN 
                  B(2) = 0.D0 
                  B(3) = 0.D0 
               ELSE 
                  KFIT = KFIT + 1 
                  B(2) = PARM(KFIT) 
                  IF (NBACK <= 2) THEN 
                     B(3) = 0.D0 
                  ELSE 
                     KFIT = KFIT + 1 
                     B(3) = PARM(KFIT) 
                  ENDIF 
               ENDIF 
               
!  --- DETERMINE CURRENT WAVENUMBER SCALE MULTIPLIER               
               IF (ISPARM /= 2) THEN 
                  IF (ISPARM == 0) GO TO 3 
                  IF (ISPARM == 3) GO TO 131 
                  
!  --- SINGLE PARAMETER FOR ALL BANDPASSES
                  WSCALE = PARM(NBKFIT+1) !*0.1D0 
                  !print *, 1, wscale
                  GO TO 14 
               ENDIF 
               
!  --- INDEPENDENT PARAMETER FOR EACH BANDPASS
               WSCALE = PARM(NBKFIT+IBAND) !*0.1d0
               !print *, 2, wscale
               GO TO 14 
               
!  --- INDEPENDENT PARAMETER FOR EACH FIT
  131          CONTINUE 
               WSCALE = PARM(NBKFIT+(IBAND-1)*N+JSCAN) 
               !print *, 3, wscale
               GO TO 14 
               
!  --- NO WAVENUMBER SHIFT
    3          CONTINUE 
               WSCALE = 0.0D0 
               !print *, 0, wscale
 
!  --- CALCULATE SHIFT IN WAVENUMBERS
   14          CONTINUE 
               DWAVE = 0.5D0*(WAVE3(IBAND)+WAVE4(IBAND))*((WAVFAC + WSCALE) - &
                  1.D0) 

!  --- CALCULATE NUMBER OF MONOCHROMATIC POINTS TO SHIFT
               DSHIFT = DWAVE/DN 
               MSHIFT = NINT(DSHIFT)
               FRACS = DSHIFT - MSHIFT 
 
!  --- DETERMINE ZERO LEVEL OFFSET TO APPLY
               IF (IZERO(IBAND) == 1) THEN 
               ! kzero increments for each band
                  KZERO = KZERO + 1 
                  ZSHIFT(IBAND,JSCAN) = PARM(NBKFIT+NSHIFT+KZERO) 
               ELSE IF (IZERO(IBAND) == 2 ) THEN
               ! if we're not calculating it then use shift from first band/spec
                  ZSHIFT(IBAND,JSCAN) = ZSHIFT(1,JSCAN)
               ENDIF 
               !print *, iband, ZSHIFT(IBAND,JSCAN)
               
!  --- DETERMINE PHASE ERROR TO APPLY
               PHI = 0.D0 
               IF (IPHASE /= 0) THEN 
                  KPHASE = KPHASE + 1 
                  PHI = PARM(NBKFIT+NSHIFT+NZERO+NEAPRT+NEPHSRT+NSOLAR+NDIFF+&
                     KPHASE) 
               ENDIF 
               
!  --- COMPUTE FFTS IF REQUIRED
               IF (IPARM == 1) GO TO 15 
               NCOUNT = 1 + NBKFIT + NSHIFT + NZERO 
               IF (IPARM <= NCOUNT) GO TO 16 
   15          CONTINUE 
               CALL FSPEC1 (IBAND, MONONE, MXONE) 
               CALL FSPEC2 (IBAND, MONONE, PHI) 
               
!  --- COMPUTE RESIDUALS
   16          CONTINUE 
               N1 = NSTART(IBAND) + MSHIFT + MONONE - 1 
               N2 = N1 + (NPRIM(IBAND)-1)*NSPAC 
 
!  --- CHECK FOR TCALC OVERFLOW OF BAND SPACE
          IF (N1<MONONE .OR. N2>=MONONE+NM(IBAND)) GO TO 17 
               N3 = NPRIM(IBAND) 
 
               SMM = 0.D0 
               DO J = 1, N3 
                  I = N1 + (J - 1)*NSPAC 
                  JATMOS = JATMOS + 1 
                  TCALL = TCONV(I) 
                  TCALH = TCONV(I+1) 
                  TCALI = TCALL + FRACS*(TCALH - TCALL) 
                  YS = (J - 1)*SPAC 
                  WAVE_X(JATMOS) = YS + WSTART(IBAND) 
                  BKGND = B(1)*(1.0D0 + B(2)*YS+B(3)*YS*YS) 
                  BKGND = BKGND*(1.0D0/(1.0D0 + ZSHIFT(IBAND,JSCAN))) 
 
!-- FIT CHANNEL PARMS IF NEEDED ----------------------------------------!PWJ
                  IF (NBEAM_OF_BAND(IBAND) /= 0) THEN 
                     YC(JATMOS) = FIT_CHANNEL_PARMS(IBAND,JSCAN,J,DBLE(BKGND),TCALI,&
                        TEMPP)               
                     IF (OUTPUT_CHANNEL_FILES) THEN 
                        AMP_Y(JATMOS) = TEMPP    !for_channel_value_files 
                     ENDIF 
                  ELSE                
                     YC(JATMOS) = BKGND*(DBLE(TCALI) + ZSHIFT(IBAND,JSCAN)) 
                  ENDIF          
                  !if(yc(jatmos) ==0.0d0 ) then
                  !   print *, jatmos, j, jscan, iband
                  !endif           
                  SMM = SMM + YC(JATMOS) 
               END DO 

               YCAVE = SMM/N3 
               YC(JATMOS-N3+1:JATMOS) = YC(JATMOS-N3+1:JATMOS)/YCAVE 

               IF (GASOUTTYPE > 0) THEN
                  ! SAVE TCALC
                  ALLOCATE (TCONVSAV(NMONSM), STAT=NAERR)
                  IF (NAERR /= 0) THEN
                    WRITE (6, *) 'COULD NOT ALLOCATE TCONVSAV ARRAY'
                    WRITE (6, *) 'ERROR NUMBER = ', NAERR
                    STOP 'SETUP ALLOCATION'
                  ENDIF
                  TCONVSAV(:NMONSM) = TCONV(:NMONSM)
                  TCALC(1,:NMONSM) = TCALC(2,:NMONSM)
                  ! TEMPORARILY TURN OF FLAG SO FSPEC1 WILL NOT APPLY TCO 
                  IFCOSAVE=IFCO
                  IFCO = 0

                  IF (GASOUTTYPE == 1) THEN
                     WRITE(GASFNAME,600)IBAND,JSCAN         
                  ELSE
                     IF (iter == -1) THEN
                        WRITE(GASFNAME,610)IBAND,JSCAN
                     ELSE
                        IF (iter < 10) THEN
                           WRITE(GASFNAME,620)IBAND,JSCAN,ITER
                        ELSE
                           WRITE(GASFNAME,625)IBAND,JSCAN,ITER      
                        ENDIF
                     ENDIF
                  ENDIF
                  
                  WRITE(TITLE,630)
                  OPEN(UNIT=80, FILE=GASFNAME, STATUS='REPLACE', ERR=555)
                  WRITE (80, 640) TITLE
                  WRITE (80, *) WSTART(IBAND), WSTOP(IBAND), SPAC, N3
                  !SMM = 0.0D0
                  !DO iii=JATMOS-N3+1,JATMOS
                  !   SMM = MAX(SMM, YC(iii))
                  !ENDDO
                  !print *, smm
                  DO iii=JATMOS-N3+1,JATMOS
                     WRITE (80, *) YC(iii) !/SMM
                  ENDDO
                  CLOSE (80)

                  DO NR = 1, NRETB(IBAND)
                     CALL GASNTRAN(NR,IBAND,JSCAN,2,MONONE,MXONE)
                     !  --- COMPUTE FFTS 
                     CALL FSPEC1 (IBAND, MONONE, MXONE) 
                     CALL FSPEC2 (IBAND, MONONE, PHI) 

                     IF (NR < 10) THEN
                        IF (GASOUTTYPE == 1) THEN
                            WRITE(GASFNAME,650)NR,IBAND,JSCAN
                        ELSE
                            IF (iter == -1) THEN
                               WRITE(GASFNAME,660)NR,IBAND,JSCAN
                            ELSE
                               IF (iter < 10) THEN
                                  WRITE(GASFNAME,670)NR,IBAND,JSCAN,iter
                               ELSE
                                  WRITE(GASFNAME,675)NR,IBAND,JSCAN,iter
                               ENDIF
                            ENDIF
                        ENDIF
                     ELSE
                        IF (GASOUTTYPE == 1) THEN
                           WRITE(GASFNAME,680)NR,IBAND,JSCAN
                        ELSE
                           IF (iter == -1) THEN
                              WRITE(GASFNAME,690)NR,IBAND,JSCAN
                           ELSE
                              WRITE(GASFNAME,700)NR,IBAND,JSCAN,iter
                           ENDIF
                        ENDIF
                     ENDIF
                     WRITE(TITLE,710)NR

                     OPEN(UNIT=80, FILE=GASFNAME, STATUS='REPLACE', ERR=555)
                     WRITE (80, 640) TITLE
                     WRITE (80, *) WSTART(IBAND), WSTOP(IBAND), SPAC, N3
                     DO J = 1, N3 
                        I = N1 + (J - 1)*NSPAC 
                        WRITE (80, *) DBLE(TCONV(I))
                     ENDDO
                     CLOSE (80)
                  ENDDO

                  IFCO = IFCOSAVE
                  IF (IFCO /= 0) THEN 
                     CALL ZERONTRAN(IBAND,JSCAN,2,MONONE,MXONE)
                     !  --- COMPUTE FFTS 
                     CALL FSPEC1 (IBAND, MONONE, MXONE) 
                     CALL FSPEC2 (IBAND, MONONE, PHI) 

                     IF (GASOUTTYPE == 1) THEN
                        WRITE(GASFNAME,720)IBAND,JSCAN
                     ELSE
                        IF (ITER == -1 ) then
                           WRITE(GASFNAME,730)IBAND,JSCAN
                        ELSE
                           IF (iter < 10) THEN
                              WRITE(GASFNAME,740)IBAND,JSCAN,iter
                           ELSE
                              WRITE(GASFNAME,745)IBAND,JSCAN,iter
                           ENDIF
                        ENDIF
                     ENDIF
                     WRITE(TITLE,750)

                     OPEN(UNIT=80, FILE=GASFNAME, STATUS='REPLACE', ERR=555)
                     WRITE (80, 640) TITLE
                     WRITE (80, *) WSTART(IBAND), WSTOP(IBAND), SPAC, N3
                     DO J = 1, N3 
                        I = N1 + (J - 1)*NSPAC 
                        WRITE (80, *) DBLE(TCONV(I))
                     ENDDO
                     CLOSE (80)
                  ENDIF

                  GOTO 557

                  ! File Open Error handler
555               CONTINUE
                  WRITE (6, 556)

557               CONTINUE
                  IFCO=IFCOSAVE
                  ! RESTORE TCALC
                  TCALC(2,:NMONSM) = TCALC(1,:NMONSM)
                  TCONV(:NMONSM) = TCONVSAV(:NMONSM)
                  DEALLOCATE (TCONVSAV)
                  !CALL TALL
                  !  --- COMPUTE FFTS 
                  !CALL FSPEC1 (IBAND, MONONE, MXONE) 
                  !CALL FSPEC2 (IBAND, MONONE, PHI) 
               ENDIF

               MONONE = MONONE + NM(IBAND) 
            END DO SPEC 
            MXONE = MXONE + NM(IBAND)   ! index in TCO and CROSS arrays as start of current band 
         END DO BAND 
         
         DO I = 1, NFIT 
            FX = TOBS(I) - YC(I) 
            SUMSQ = SUMSQ + FX*FX 
         END DO 
         
         IF (ICOUNT <= 1) THEN 
            !STDEV = 100.D0*SQRT(SUMSQ/(NFIT - 1)) 
            RMS = 100.D0*SQRT(SUMSQ/NFIT) 
            WRITE (16, 26) ITER, RMS, NVAR, NFIT 
            WRITE (*, 26) ITER, RMS, NVAR, NFIT 
            WRITE (16, 888) (PARM(I),I=1,NVAR) 
 
            IF (OUTPUT_CHANNEL_FILES) THEN 
               IF (ITER == 1) THEN       !for_channel_value_files
                  WRITE (30, 3000) (WAVE_X(I),AMP_Y(I),I=1,NFIT) 
                  CLOSE(30) 
               ENDIF 
               IF (ITER == 2) THEN       !for_channel_value_files
                  WRITE (40, 3000) (WAVE_X(I),AMP_Y(I),I=1,NFIT) 
                  CLOSE(40) 
               ENDIF 
            ENDIF 
 
!  --- UPDATE CALCULATED SPECTRUM ARRAY 
! first trip through update spectra
            YN = YC(:NFIT) 
 
         ELSE 
!  --- UPDATE ARRAY OF PARTIAL DERIVATIVES  
! next nvar trips update a row in K
            KN(:NFIT,ICOUNT-1) = (YC(:NFIT)-YN)/DEL             
         ENDIF 
 
      END DO PARAM
 
! --- ZERO K MATRIX FOR MOLECULES NOT INCLUDED IN FIT OF A BAND 
      BAND1: DO IBAND = 1, NBAND 
         NS = NSCAN(IBAND)  
         IF (NS == 0) CYCLE
         IF( IBAND > 1 ) THEN
            NS1 = SUM(NPRIM(1:IBAND-1))+1
            NS2 = SUM(NPRIM(1:IBAND))     
         ELSE    
            NS1 = 1
            NS2 = SUM(NPRIM(1:IBAND))     
         ENDIF     
              
         SPEC1: DO JSCAN = 1, NS
            NR = NRETB(IBAND) 
            
            RET1: DO KK = 1, NRET
               IF( NGIDX(KK,0,IBAND) == 0 ) THEN
                 KN( NS1:NS2 , NGIDX(KK,1,0): NGIDX(KK,2,0) ) = 0.0D0
               ELSE 
               ENDIF  
               
            END DO RET1
         END DO SPEC1 
      END DO BAND1 
 
 !  --- PRINT OUT PARM ARRAY
      WRITE(89,164) PARM(:NVAR)
      
      RETURN  
 
 2000 CONTINUE 
      WRITE (*, *) ' CAN NOT CREATE 1st ITERATION CHANNEL SPECTRA DATA FILE' 
      WRITE (*, *) 'FILENAME: "', TFIL30, '"' 
      STOP                                       ! for_channel_value_files 

 2010 CONTINUE 
      WRITE (*, *) ' CAN NOT CREATE 2nd ITERATION CHANNEL SPECTRA DATA FILE' 
      WRITE (*, *) 'FILENAME: "', TFIL40, '"' 
      STOP                                       ! for_channel_value_files 
 
   17 CONTINUE 
      WRITE (16, 18) N1, N2, IBAND, NSTART(IBAND), MSHIFT, MONONE, NPRIM(IBAND)&
         , NSPAC 
      WRITE (16,*) "WAVENUMBER SHIFT OUT OF SPECTRAL RANGE."
      TFLG=.TRUE.
      RETURN

   18 FORMAT(/,' !!! ABORT !!! TCALC ARRAY OVERFLOW : ',/,' N1    =',I10, &
         ' N2    =',I10,' IBAND =',I6,/,' NSTART=',I6,' MSHIFT=',I10, &
         ' MONONE=',I6,/,' NPRIM =',I6,' NSPAC =',I6) 
   26 FORMAT(/,' ITER=',I2,' RMS(%)=',F10.7,' NVAR=',I3,' NFIT=',I6) 
  !162 FORMAT(/,' EFFECTIVE APODIZATION PARAMETER =',F8.3) 
  !163 FORMAT(F8.3) 
  164 FORMAT( 255ES26.18 )
 556  FORMAT(/,' Could not create individual gas file')  
 600  FORMAT('allgases.',I1,'.',I1)  
 610  FORMAT('allgases.',I1,'.',I1,'.last')
 620  FORMAT('allgases.',I1,'.',I1,'.',I1) 
 625  FORMAT('allgases.',I1,'.',I1,'.',I2)
 630  FORMAT('SFIT2 ALLGASES file')
 640  FORMAT(A80) 
 650  FORMAT('gas',I1,'.',I1,'.',I1)
 660  FORMAT('gas',I1,'.',I1,'.',I1,'.last')
 670  FORMAT('gas',I1,'.',I1,'.',I1,'.',I1)
 675  FORMAT('gas',I1,'.',I1,'.',I1,'.',I2)
 680  FORMAT('gas.',I2,'.',I1,'.',I1)
 690  FORMAT('gas',I2,'.',I1,'.',I1,'.last')
 700  FORMAT('gas.',I2,'.',I1,'.',I1,'.',I1)
 710  FORMAT('SFIT2 GAS ',I2,' file') 
 720  FORMAT('solar.',I1,'.',I1)
 730  FORMAT('solar.',I1,'.',I1,'.last')
 740  FORMAT('solar.',I1,'.',I1,'.',I1) 
 745  FORMAT('solar.',I1,'.',I1,'.',I2) 
 750  FORMAT('SFIT2 SOLAR file')
 
  888 FORMAT(5(1P,E14.7,1X)) 
 3000 FORMAT(2(E14.6)) 

      END SUBROUTINE FM 
