      SUBROUTINE FSPEC1(IBAND, MONONE, MXONE) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param
      USE params_M 
      USE jmix_dat_M
      USE zfft_dat_M
      USE bands_dat_M
      USE trans_dat_M 
      USE solar
!...Translated by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
!...Switches: -yf12               
!      TRUNCATE FFT OF SPECTRUM TO SIMULATE FOURIER SPECTROMETER
!      UNAPODIZED OUTPUT
 
      IMPLICIT NONE
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      INTEGER :: IBAND 
      INTEGER :: MONONE 
      INTEGER :: MXONE 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      INTEGER :: HP, LF, NMON, MPTBND, MFFTBD, NAERR
      INTEGER, DIMENSION(:),ALLOCATABLE :: IW 
!-----------------------------------------------
!
 
!     SAVE AMPLITUDE-- ASSUME SAMPLING INTO WINGS
!
!     FILL COMPLEX ARRAY IMGG
!
      ALLOCATE (IW(MFFT(IBAND)+1), STAT=NAERR)
      IF (NAERR /= 0) THEN
        WRITE (6, *) 'Could not allocate IW array'
        WRITE (6, *) 'Error Number = ', NAERR
        STOP 'FSPECT1 ALLOCATION'
      ENDIF
      LF = LOWFIL(IBAND) 
      NMON = NM(IBAND) 
      MPTBND = MPT(IBAND) 
      MFFTBD = MFFT(IBAND) 
      IMGG(:LF) = 0.D0 
      HP = HIFILL(IBAND) + 1 
      IMGG(HP:MPTBND) = 0.D0 
      IF (IFCO /= 1) THEN 
         AMP = TCALC(2,MONONE) 
         IMGG(1+LF:NMON+LF) = TCALC(2,MONONE:NMON-1+MONONE) - AMP 
      ELSE 
         AMP = TCALC(2,MONONE)*TCO(MXONE) 
         IMGG(1+LF:NMON+LF) = TCALC(2,MONONE:NMON-1+MONONE)*TCO(MXONE:NMON-1+&
            MXONE) - AMP 
      ENDIF 
!  --- COMPUTE FORWARD TRANSFORM
      CALL FFT (IMGG, MFFTBD, IW) 
      DEALLOCATE(IW)
      RETURN  
      END SUBROUTINE FSPEC1 
