      SUBROUTINE GETSPEC(IBAND, JSCAN, FIRST_CALL) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param
      USE params_M 
      USE jmix_dat_M
      USE bands_dat_M
      USE spec_dat_M
      USE tfiles_dat_M 
      USE wwv_dat_M
!...Translated by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
!...Switches: -yf12               
 
      IMPLICIT NONE
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      INTEGER  :: IBAND 
      INTEGER  :: JSCAN 
      LOGICAL  :: FIRST_CALL
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      INTEGER :: MAXPT, NREF, NPFILE, I, NPTSB
      REAL(DOUBLE) :: R4AMP, WLIM1, WLIM2, WHI, WLOW, SMM, WAVE, TAVE 
      REAL(DOUBLE), SAVE :: SPACDIF
      CHARACTER :: TITLE*80 
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
      DATA MAXPT / MMAX /  
!
!  --- SUBROUTINE TO READ ASCII ATMOSPHERIC DATA
!
      WLIM1 = WAVE3(IBAND) 
      WLIM2 = WAVE4(IBAND) 
      NREF = NATMOS + 1 
      
   19 CONTINUE 
      READ (15, 888, END=444) TITLE 
      GO TO 445 
  444 CONTINUE 
      STOP 'GETSPEC: SPECTRAL DATA NOT FOUND IN ASCII FILE...STOP.' 
  445 CONTINUE 
      READ (15, *) WLOW, WHI, SPAC, NPFILE
      !print *, WLOW, WHI, SPAC, NPFILE
      IF (WLIM1>WHI .OR. WLIM2<WLOW) THEN 
         DO I = 1, NPFILE 
            READ (15, *) R4AMP 
         END DO 
         GO TO 19 
      ENDIF 
 
      IF (FIRST_CALL) THEN
         SPACDIF = SPAC
      ELSE   
         IF ( ABS(SPACDIF-SPAC) > SPAC/100000. ) THEN
            WRITE(16,104)            
            PRINT *,"POINT SPACING MUST BE THE SAME FOR ALL SPECTRA"
            STOP
            ENDIF
      ENDIF
      
      WRITE( 16,*) ""
      WRITE (16, 10) TITLE 
      WRITE (16, 11) WLOW, WHI, SPAC, NPFILE 
 
      IF (IBAND == NBAND) THEN 
         WRITE (31, 10) TITLE                    !short 
      ENDIF 
      WRITE (6, '(4X,A76)') TITLE 
 
      NPTSB = 0 
      SMM = 0.D0 
      DO I = 1, NPFILE 
         READ (15, *, END=20) R4AMP 
         WAVE = WLOW + (I - 1)*SPAC 
         IF (WAVE<WLIM1 .OR. WAVE>WLIM2) CYCLE  
         NPTSB = NPTSB + 1 
         NATMOS = NATMOS + 1
         IF (NATMOS > MAXPT) GO TO 40 
         WWV(NATMOS) = WAVE 
         TOBS(NATMOS) = R4AMP 
         SMM = SMM + TOBS(NATMOS) 
         IF (NPTSB == 1) WSTART(IBAND) = WAVE 
         WSTOP(IBAND) = WAVE 
      END DO 
   20 CONTINUE 

      NPRIM(IBAND) = NPTSB 
      WRITE (16, 102) WSTART(IBAND), WSTOP(IBAND), NPTSB, NATMOS 
      IF (NPTSB /= 0) GO TO 60 
   
! ***
!       NO POINTS FOUND
! ***
      WRITE (16, 103) 
      CLOSE(6) 
      CLOSE(15) 
      STOP  
      
! ***
!    BUFFER TRUNCATION
! ***
   40 CONTINUE 
      WRITE (16, 101) MAXPT 
      WRITE (16, 102) WSTART(IBAND), WSTOP(IBAND), NPTSB, NATMOS 
      CLOSE(16) 
      CLOSE(15) 
      STOP  
      
!   NORMALIZE AMPLITUDES TO AVERAGE VALUE
   60 CONTINUE 
      TAVE = SMM/(NATMOS - NREF + 1) 
      TOBS(NREF:NATMOS) = TOBS(NREF:NATMOS)/TAVE 
      RETURN  
      
   10 FORMAT(1X,A80) 
   11 FORMAT(/,' --- SPECTRAL DATA FILE PARAMETERS ---',/,&
         ' FIRST POINT (CM-1)   =',F10.4,/,' LAST POINT (CM-1)    =',F10.4,/,&
         ' POINT SPACING (CM-1) =',F12.8,/,' NUMBER OF POINTS     =',I6) 
  101 FORMAT(' GETSPEC: ABORT-SPECTRAL DATA ARRAY SIZE LIMIT EXCEEDED-MAX =',I5) 
  102 FORMAT(2X,'WSTART=',F12.4,' WSTOP=',F12.4,' NPRIME=',I6, ' NATMOS=', I6) 
  103 FORMAT(/,/,5X,'NO POINTS....ABORT!'/,/) 
 104  FORMAT("GETSPEC: ABORT... POINT SPACING MUST BE THE SAME FOR ALL SPECTRA")
  !667 FORMAT(/,' ASCII SPECTRAL FILE NOT FOUND - TAPE15') 
  !801 FORMAT(5X,'USER RANGE ',2F10.4,' NOT ON FILE') 
  888 FORMAT(A80) 
      RETURN  
      END SUBROUTINE GETSPEC 
