      MODULE ISOTOPE
      
      USE vast_kind_param
      USE params_M
      USE molec_dat_M
      USE slat_dat_M
      USE jmix_dat_M
      USE vibfn_dat_M
      USE tfiles_dat_M
      
      IMPLICIT NONE
      
      INTEGER                                :: NISOSEP
      INTEGER, DIMENSION(ISOMAX)             :: OLDID, OLDISO, NEWID, NEWISO
      REAL(DOUBLE), DIMENSION(LAYMAX,ISOMAX) :: NEWVMR
      REAL(DOUBLE)                           :: ISOSCALE(ISOMAX)
      LOGICAL                                :: USEISO
      CHARACTER, DIMENSION(ISOMAX)           :: NEWNAME*7
      
      CONTAINS
      
      SUBROUTINE RDISOFILE
      
      CHARACTER, DIMENSION(ISOMAX)    :: OLDNAME*7
      INTEGER, DIMENSION(ISOMAX)      :: NEWMODE
      INTEGER                         :: I
      REAL(DOUBLE), DIMENSION(ISOMAX) :: NEWMASS
      !INTEGER, DIMENSION(2,MAXVIBVALS,ISOMAX) :: NEWIVIB
      LOGICAL                         :: ISFILE
      
      OLDID = -1
      OLDISO = -1
      NEWID = -1
      NEWISO = -1
      OLDNAME = 'OTHER'
      NEWNAME = 'OTHER'
      NEWVMR = 0.0D0
      NEWMASS = 0.0D0
      NEWMODE = 0
      
      IF (.NOT. USEISO) THEN
         WRITE(16,35)
         ISFILE= .FALSE.
         RETURN
      ENDIF
      
!  --- CHECK FOR FILE - ISOTOPE SEPARATION INPUT FILE  
      INQUIRE(FILE=TFIL21, EXIST=ISFILE)
      IF( .NOT. ISFILE ) THEN         
          WRITE(16,30)
          RETURN
      ENDIF    
      
      OPEN(UNIT=21, FILE=TFIL21, STATUS='OLD', ERR=19 ) 
      GOTO 20
  19  WRITE(16,34) TRIM(TFIL21)
      RETURN
  
  20  CONTINUE
      READ(21,*) NISOSEP
      DO I=1, NISOSEP
          READ(21,'(A7)') OLDNAME(I)
          READ(21,*) OLDID(I), OLDISO(I)
          READ(21,'(A7)') NEWNAME(I)
          READ(21,*) NEWID(I), NEWISO(I), NEWMASS(I), NEWMODE(I), ISOSCALE(I)
          WRITE(*,*) NEWID(I), NEWISO(I), NEWMASS(I), NEWMODE(I), ISOSCALE(I)          
!          DO J=1, MAXVIBVALS
!              DO K=1, 2
!			      NEWIVIB(K,J,I) = 0.0D0
!			  ENDDO    
!		  ENDDO
!		  READ(21,*) NEWIVIB(:2,:12,I)
          READ(21,*) NEWVMR(:KMAX,I)
      ENDDO
      
      CLOSE(21)

      WRITE(16,31) NISOSEP
      WRITE(16,32)

      DO I=1, NISOSEP
          IF (NAME(NEWID(I)) /= 'OTHER  ') THEN
             WRITE(16,*)'Molecule ', NEWID(I), ' is already in use as ',NAME(NEWID(I))
             WRITE(16,*)'Cannot assign isotope to existing molecule'
             STOP 'ISOTOPE : BAD ISOTOPE MAPPING'
          ENDIF
          NAME(NEWID(I)) = NEWNAME(I)
          NHIISO(NEWID(I)) = 1
          XMASS(NEWISO(I),NEWID(I)) = NEWMASS(I)
          XMASS(NEWISO(I)+1:,NEWID(I)) = 0.0D0
          NMODE(NEWID(I)) = NEWMODE(I)
!          DO J=1, MAXVIBVALS
!              DO K=1, 2
!			      IVIB(K,J,NEWID(I)) = NEWIVIB(K,J,I)
!			  ENDDO    
!		  ENDDO
          WRITE(16,33) OLDNAME(I), OLDID(I), OLDISO(I), NEWNAME(I), &
                       NEWID(I), NEWISO(I), ISOSCALE(I)      
!          WRITE(16,36) (IVIB(1:2,J,NEWID(I)),J=1,12)
      ENDDO    
       
      RETURN
  30  FORMAT(/,"ISOTOPE - NO ISOTOPE SEPARATION PARAMETER FILE.")     
  31  FORMAT(/,"NUMBER OF ISOTOPES TO SEPARATE =", I2)
  32  FORMAT(" OLD NAME, ID, ISO    NEW NAME, ID, ISO   S-SCALE")
  33  FORMAT(2(A7,4x,i2,2x,i2,4x),f8.6)
  34  FORMAT(/,"ISOTOPE - COULD NOT OPEN ISOTOPE SEPARATION FILE :",A)    
  35  FORMAT(/,"ISOTOPE - NO ISOTOPE SEPARATION SELECTED")
!  36  FORMAT(6(I8,1X,I2))
     
      END SUBROUTINE RDISOFILE
      
      END MODULE ISOTOPE
