      MODULE OPT

      USE vast_kind_param
      USE params_M
      USE tfiles_dat_M
      USE profil_dat_M
      USE jmix_dat_M
      USE bands_dat_M

      IMPLICIT NONE

      !REAL(DOUBLE)                       :: SHAT(NMAX,NMAX)
      LOGICAL                             :: Tflg
      REAL(DOUBLE), DIMENSION(NMAX*NMAX)  :: KSK, SPKSKINV
      REAL(DOUBLE), DIMENSION(NMAX,NMAX)  :: SA, SAINV, SHAT
      REAL(DOUBLE), DIMENSION(NMAX,MMAX)  :: KS
      REAL(DOUBLE), DIMENSION(MMAX)       :: SE
      !EQUIVALENCE (KSK, SPKSKINV)

      CONTAINS

      SUBROUTINE OPT_3(Y, XA, XHAT, YHAT, M, N, CONVERGE, MAXITER, &
         TOL, DEBUG, RETFLG, DIVWARN, ITER, WRTK, SNR, ISMIX, NLEV, GASOUTTYPE )

!...Translated by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03
!...Switches: -yf12

! 17SEP02
!    - output format of kfile 2000e16.8 - compatible w/ idl
!      32676 chars per line

!
!
! Version 2; 1/17/91; bjc
! version x; 6/2/95; bjc
! Version 3; 10/12/95; bjc
! Retrieval/forward model switch (RetFlg) added
! Version 4; 8/13/98; psm
! DivWarn and Iter passed out, & WrtK option added
!
! KFlg tells FM whether to calculate weighting functions - BJC 12/96
!
! change from version 1: Se is now a vector; a new matrix arithmetic
! subroutine (MultDiag) has been added
!
!

!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      INTEGER       :: N, M, ISMIX, MAXITER, ITER, GASOUTTYPE
      REAL(DOUBLE)  :: TOL
      LOGICAL       :: CONVERGE, DEBUG, RETFLG, DIVWARN, WRTK
      REAL(DOUBLE)  :: Y(M)
      REAL(DOUBLE)  :: XA(N) ! PARM on input
      REAL(DOUBLE)  :: XHAT(NMAX)
      REAL(DOUBLE)  :: YHAT(MMAX)

!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      INTEGER     :: I, J, ONE, SGN, INDXX, KK, NS, IYDX1, IYDX2, JSCAN, IBAND, NLEV
      REAL(DOUBLE)   :: RMSDELY, RMSDY, RMSIM1, CHGY, UNCY, SNR, SQRMS, VQRMS, RMSKDX
      REAL(DOUBLE), DIMENSION(MMAX) :: SEINV, YN, DY, DELY, KDX, DYMKDX
      REAL(DOUBLE), DIMENSION(NMAX) :: XNP1, XN, DX, KSDYMKDX, DELX
      REAL(DOUBLE), DIMENSION(NMAX*NMAX)     :: SPKSK, SHATINV
      REAL(DOUBLE), DIMENSION(LAYMAX,LAYMAX)    :: SAINP
      REAL(DOUBLE), DIMENSION(LAYMAX)        :: Saroot
      REAL(DOUBLE), DIMENSION(MMAX*NMAX)     :: KHAT, KN
      REAL(DOUBLE), DIMENSION(NMAX*MMAX)     :: KNT, KHATT !, KS
      LOGICAL :: KFLG, FILEOPEN

      !EQUIVALENCE (KSK, SPKSKINV)
      EQUIVALENCE (KHAT, KN), (KNT, KHATT), (SPKSK, SHATINV), (YN, KDX), (DX, KSDYMKDX)
      DATA ONE/ 1/

      YN = 0.0D0
      DY = 0.0D0
      XN = 0.0D0
      DX = 0.0D0
      KN = 0.0D0
      DELX = 0.0D0
      XNP1 = 0.0D0
      FILEOPEN = .FALSE.
      CONVERGE = .FALSE.
      DEBUG    = .FALSE.
      DIVWARN  = .FALSE.

      IF (DEBUG) WRITE (*, *) ' m,n:', M, N
      KFLG = .TRUE.

      RMSDELY = 0.D0
      DO I = 1, M
         DELY(I) = SQRT(SE(I))
         RMSDELY = RMSDELY + SE(I)
      END DO

      RMSDELY = SQRT(RMSDELY/M)
      IF (DEBUG) WRITE (0, *) 'rmsdely= ', RMSDELY

! XN working version of XA (PARM)
      XN(:N) = XA(:N)
      CALL INVRT( SA(:N,:N), SAINV(:N,:N), N )

! Substitute SaInv values for any profile retrieve gas from file "sa.input"
      ! loop over retrieval gases
      INDXX = ISMIX
      DO KK = 1, NRET
         ! pick out gases with set flag (IFOFF=5)
            IF (( IRTYPE(KK) /= 1 ) .AND. ( IFOFF(KK) == 5 )) THEN
               IF ( .NOT. FILEOPEN ) THEN
                  OPEN(62, FILE=TFIL62, STATUS='old', ERR=100, POSITION='asis')
                  WRITE(16,301) TRIM(TFIL62)
                  FILEOPEN = .TRUE.
               ENDIF
               WRITE(16,302) KK, IFOFF(KK)
            ! get diagonal fractional variances from binput && already squared
            DO I = 1, IRTYPE(KK)
               SAROOT(I) = SQRT( SA(I+INDXX,I+INDXX) )
            END DO
            ! read in put new Sainv values
            READ(62,*) SAINP(:IRTYPE(KK), :IRTYPE(KK) )
            ! scale and store them in SAINV
            DO I = 1, IRTYPE(KK)
               DO J = 1, IRTYPE(KK)
                  SAINV(I+INDXX,J+INDXX) = SAINP(I,J)*( 1.0D0/(SAROOT(I)*SAROOT(J)))
               END DO
            END DO
         ELSE
            WRITE(16,303) KK, IFOFF(KK)
         ENDIF
         ! bump up index of mixing ratio block in SA(INV) matrix
         INDXX = INDXX + IRTYPE(KK)
      ENDDO
      IF( FILEOPEN ) CLOSE(62)

      SEINV(:M) = 1.D0/SE(:M)
      ITER = 0
      RMSDY = 0.D0

! For forward model calc. only:
      IF (.NOT.RETFLG .OR. MAXITER==0) THEN
         IF (.NOT.WRTK) THEN
            KFLG = .FALSE.
         ENDIF
         XHAT(:N) = XA(:N)
         SHAT(:N, :N) = SA(:N, :N)
         CALL FM (XHAT, YHAT, KHAT, M, N, KFLG, 0, Tflg, GASOUTTYPE)
         WRITE (0, *) 'opt returning early...'
         IF (WRTK) THEN
            ! write out K's - BJC 8/97, copied here MP 2/2005
            OPEN(66, FILE=TFIL66, STATUS='replace', POSITION='asis')
            WRITE (66, *) 'K by columns m x n'
            WRITE (66, *) M, N, ISMIX, NLEV

            DO I = 1, N
               WRITE (66, '(2000ES26.18)') (KHAT((I-1)*M+J),J=1,M)
            END DO

            WRITE (66, *) 'SeInv (diagonal)'
            WRITE (66, '(2000ES26.18)') (SEINV(I),I=1,M)

            WRITE (66, *) 'SaInv n x n (block diagonal)'
            DO I = 1, N
               WRITE (66, '(2000ES26.18)') (SAINV(I,J), J=1, N)
            END DO

            WRITE (66, *) 'Sa n x n (block diagonal)'
            DO I=1,N
               WRITE(66, '(2000ES26.18)') (SA(I,J), J=1, N)
            END DO

            CALL TRNSPS (KHAT, KHATT, N, M)
            CALL MULTDIAG (KHATT, SEINV, KS(:N,:M), N, M)
            CALL MULT (KS(:N,:M), KHAT, KSK, N, M, N)
            SGN = 1
            CALL ADDSUB( SAINV(:N,:N), KSK, SHATINV, N, N, SGN)
            !print *, "INVRT SHATINV -> SHAT"
            CALL INVRT( SHATINV, SHAT(:N,:N), N)

            WRITE (66, *) 'Shat n x n'
            DO I=1,N
               WRITE(66, '(2000ES26.18)') (SHAT(I,J), J=1, N)
            END DO

            CLOSE(66)

         ENDIF
         RETURN
      ENDIF

! For retrieval:
!
! iteration loop
!
   10 CONTINUE
      ITER = ITER + 1
      IF (DEBUG) WRITE (*, *) ' iteration:', ITER

! calc yn,Kn
      CALL FM (XN, YN, KN, M, N, KFLG, ITER, Tflg, GASOUTTYPE)
      IF (Tflg) RETURN

      IF (DEBUG) THEN
         WRITE (0, *) 'b- ret from FM'
         WRITE (0, '(6(ES12.4))') (YN(I),I=1,M)
      ENDIF
! calc x(n+1)

      SGN = -1
      CALL ADDSUB (Y, YN, DY, M, ONE, SGN)
      RMSIM1 = RMSDY
      RMSDY = DOT_PRODUCT(DY(:M),DY(:M))
      RMSDY = SQRT(RMSDY/M)
      IF (ITER>1 .AND. RMSDY-RMSIM1>2*RMSDELY) THEN
         WRITE (*, *) RMSDY, RMSIM1, RMSDELY
         WRITE (*, *) 'Threat of divergence after', ITER, ' iterations'
         DIVWARN = .TRUE.
      ENDIF
      IF (DEBUG) THEN
         WRITE (0, *) 'yn:'
         WRITE (0, '(6(ES12.4))') YN
         WRITE (0, *) 'dy:'
         WRITE (0, '(6(ES12.4))') DY
      ENDIF
      CALL ADDSUB (XA, XN, DX, N, ONE, SGN)
      IF (DEBUG) THEN
         WRITE (0, *) 'xa:'
         WRITE (0, '(6(ES12.4))') XA
         WRITE (0, *) 'xn:'
         WRITE (0, '(6(ES12.4))') XN
         WRITE (0, *) 'dx:'
         WRITE (0, '(6(ES12.4))') DX
      ENDIF
      CALL MULT (KN, DX, KDX, M, N, ONE)
      CALL ADDSUB (DY, KDX, DYMKDX, M, ONE, SGN)
      CALL TRNSPS (KN, KNT, N, M)

      IF ( SNR .GT. 0 ) GOTO 203
      IF( ITER .EQ. 1 ) THEN
         WRITE(*,304)
         BND: DO IBAND = 1, NBAND
            NS = NSCAN(IBAND)
            IF (NS == 0) CYCLE
            SPC: DO JSCAN = 1, NS
               IYDX1 = ISCNDX(1,IBAND,JSCAN)
               IYDX2 = ISCNDX(2,IBAND,JSCAN)
               SQRMS = -SNR / DOT_PRODUCT( DY(IYDX1:IYDX2), DY(IYDX1:IYDX2) )
               VQRMS = SQRT(1.D0/SQRMS)
               SEINV(IYDX1:IYDX2) = SQRMS
               DELY(IYDX1:IYDX2)  = VQRMS
               WRITE(*,305) IBAND, JSCAN, SQRMS, VQRMS, SQRT( SQRMS)
            ENDDO SPC
         ENDDO BND
         RMSDELY = 1.D0/SUM(SEINV(:M))
         RMSDELY = SQRT(RMSDELY/M)
         SNR = SQRT( SUM(SEINV(:M))/M )
         WRITE(*,300)' RMS:DELY = ',RMSDELY, 'avgSNR = ',SNR,'     TOL = ',TOL
         SE(:M) = 1.D0/SEINV(:M)
         ENDIF
 203  CONTINUE

      CALL MULTDIAG (KNT, SEINV, KS(:N,:M), N, M)
      IF (DEBUG) THEN
!          write(*,'(6(es12.4))')'KS',KS
      ENDIF
      CALL MULT (KS(:N,:M), DYMKDX, KSDYMKDX, N, M, ONE)
      IF (DEBUG) THEN
!          write(*,'(6(es12.4))')'KSdymKdx:',KSdymKdx
      ENDIF
      CALL MULT (KS(:N,:M), KN, KSK, N, M, N)
      IF (DEBUG) THEN
!          write(*,*)'KSK:',KSK
      ENDIF
      SGN = 1
      CALL ADDSUB (SAINV(:N,:N), KSK, SPKSK, N, N, SGN)
      IF (DEBUG) THEN
!          write(*,*)'SpKSK:',SpKSK
      ENDIF
      CALL INVRT (SPKSK, SPKSKINV, N)
      IF (DEBUG) THEN
!          write(*,*)'SpKSKInv',SpKSKInv
      ENDIF
      CALL MULT (SPKSKINV, KSDYMKDX, DELX, N, N, ONE)
      IF (DEBUG) THEN
         WRITE (0, *) 'delx:'
         WRITE (0, '(6(ES12.4))') DELX
      ENDIF
      CALL ADDSUB (XA, DELX, XNP1, N, ONE, SGN)
      IF (DEBUG) THEN
         WRITE (0, *) ' xnp1: '
         WRITE (0, '(6(ES12.4))') XNP1(:N)
      ENDIF

      IF (CONVERGE) GO TO 20

! check convergence
      SGN = -1
      CALL ADDSUB (XNP1, XN, DX, N, ONE, SGN)
      IF (DEBUG) THEN
         WRITE (0, *) ' dx: '
         WRITE (0, '(6(ES12.4))') DX(:N)
      ENDIF
      CALL MULT (KN, DX, KDX, M, N, ONE)
      IF (DEBUG) THEN
         WRITE (0, *) 'Tol:'
         WRITE (0, '(6(ES12.4))') TOL
      ENDIF

      RMSKDX = 0.0D0
      DO I=1,M
         RMSKDX = RMSKDX + KDX(I)*KDX(I)
         ENDDO
      RMSKDX = SQRT(RMSKDX/M)
      WRITE(*,300)' RMS:Kdx = ', RMSKDX

      IF (DEBUG) THEN
         DO I = 1, M
            WRITE (0, *) 'Kdx(i),dely(i):', KDX(I), DELY(I)
            CHGY = ABS(KDX(I))
            UNCY = ABS(TOL*DELY(I))
            IF (CHGY > UNCY) THEN
               CONVERGE = .FALSE.
               EXIT
            ENDIF
            CONVERGE = .TRUE.
         END DO
      ELSE
         DO I = 1, M
            CHGY = ABS(KDX(I))
            UNCY = ABS(TOL*DELY(I))
            IF (CHGY > UNCY) THEN
               CONVERGE = .FALSE.
               EXIT
            ENDIF
            CONVERGE = .TRUE.
         END DO
      ENDIF
      IF (CONVERGE) THEN
         GO TO 20
         !SEINV(:M) = SEINV(:M) * 0.75
         !SNR = SQRT(SUM(SEINV(:M))/M)
         !PRINT *, ""
         !PRINT *, "  Reducing final SNR to : ", SNR
         !GO TO 10
      ELSE
         IF (ITER >= MAXITER) THEN
            PRINT *,''
            PRINT *, '  No convergence after', ITER, 'iterations'
            !SEINV(:M) = SEINV(:M) * 0.75
            !SNR = SQRT(SUM(SEINV(:M))/M)
            GO TO 20
         ENDIF
         XN(:N) = XNP1(:N)
         GO TO 10
      ENDIF

   20 CONTINUE
      XHAT(:N) = XNP1(:N)
      CALL FM (XHAT, YHAT, KHAT, M, N, KFLG, -1, Tflg, GASOUTTYPE)
      IF (DEBUG) WRITE (0, *) 'a- ret from FM'

      IF (WRTK) THEN
!          write out K's - BJC 8/97
         OPEN(66, FILE=TFIL66, STATUS='replace', POSITION='asis')
         WRITE (66, *) 'K by columns m x n'
         WRITE (66, *) M, N, ISMIX, NLEV

         DO I = 1, N
            !WRITE (66, *) (KHAT((I-1)*M+J),J=1,M)
            WRITE (66, '(2000ES26.18)') (KHAT((I-1)*M+J),J=1,M)
         END DO

         WRITE (66, *) 'SeInv (diagonal)'
         !WRITE (66, '(1000ES20.12)') (SEINV(I),I=1,M)
         !WRITE (66, *) (SEINV(I),I=1,M)
         WRITE (66, '(2000ES26.18)') (SEINV(I),I=1,M)
         WRITE (66, *) 'SaInv n x n (block diagonal)'
         DO I = 1, N
            WRITE (66, '(2000ES26.18)') (SAINV(I,J), J=1, N)
            !WRITE (66, *) (SAINV((I-1)*N+J),J=1,N)
            !WRITE (66, '(2000ES26.18)') (SAINV((I-1)*N+J),J=1,N)
         END DO

         WRITE (66, *) 'Sa n x n (block diagonal)'
         DO I=1,N
            !J = (I-1)*N
            !WRITE (61, '(255ES14.6)') (SA(K),K=J+1,J+N)
            !WRITE(66, *) (SA(i,K),K=1,N)
            WRITE(66, '(2000ES26.18)') (SA(I,J), J=1, N)
         END DO

         !CLOSE(66)

      ENDIF

      IF (DEBUG) THEN
         WRITE (0, *) 'yhat:'
         WRITE (0, '(6(ES12.4))') YHAT(1:M)
         WRITE (0, *) 'xhat:'
         WRITE (0, '(6(ES12.4))') XHAT(1:N)

      ENDIF

      CALL TRNSPS (KHAT, KHATT, N, M)
      CALL MULTDIAG (KHATT, SEINV, KS(:N,:M), N, M)
      CALL MULT (KS(:N,:M), KHAT, KSK, N, M, N)
      SGN = 1
      CALL ADDSUB( SAINV(:N,:N), KSK, SHATINV, N, N, SGN)
      !print *, "INVRT SHATINV -> SHAT"
      CALL INVRT( SHATINV, SHAT(:N,:N), N)

      IF (WRTK) THEN
         WRITE (66, *) 'Shat n x n'
         DO I=1,N
            !J = (I-1)*N
            !WRITE (61, '(255ES14.6)') (SA(K),K=J+1,J+N)
            !WRITE(66, *) (SA(i,K),K=1,N)
            WRITE(66, '(2000ES26.18)') (SHAT(I,J), J=1, N)
         END DO

         CLOSE(66)

      ENDIF
      !do i=1, n
      !   write(*,'(20es12.4)') ksk(i*n)
      !enddo

      RETURN
! 1000 CONTINUE
      WRITE (*, *) 'CANNOT OPEN TRANSPOSED K FILE'
      WRITE (*, *) 'FILENAME: "', TFIL68, '"'
      RETURN

 100  PRINT *, "ERROR OPENING FILE : ", TRIM(TFIL62)
      STOP "OPT...EXITING"

 300  FORMAT( 3(A14, ES11.4 ))
 301  FORMAT(/," FILE: ", A, " OPENED IN OPT" )
 302  FORMAT("  RETRIEVAL GAS # :",I3," HAS IFOFF FLAG:", I3, &
             " ...READING IN NEW SAINV VALUES." )
 303  FORMAT("  RETRIEVAL GAS # :",I3," HAS IFOFF FLAG:", I3, " ...SKIPPING." )
 304  FORMAT( "    BAND    SCAN      SeINV         DelY         SNR" )
 305  FORMAT( 2I8,2x,2ES14.6,F7.1 )

      END SUBROUTINE OPT_3

      END MODULE OPT
