      SUBROUTINE PINP(ITRMAX,NLEV, NEGFLAG) 
!-----------------------------------------------
!   M o d u l e s 
!-----------------------------------------------
      USE vast_kind_param
      USE params_M 
      USE jmix_dat_M
      USE profil_dat_M
      USE molec_dat_M
      USE line_dat_M
      USE tfiles_dat_M
      USE isotope
      
!...Translated by Pacific-Sierra Research 77to90  4.4D  16:36:33   4/10/03  
!...Switches: -yf12               
 
      IMPLICIT NONE
!-----------------------------------------------
!   G l o b a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   D u m m y   A r g u m e n t s
!-----------------------------------------------
      INTEGER  :: ITRMAX, NEGFLAG 
      INTEGER  :: NLEV
!-----------------------------------------------
!   L o c a l   P a r a m e t e r s
!-----------------------------------------------
!-----------------------------------------------
!   L o c a l   V a r i a b l e s
!-----------------------------------------------
      INTEGER   :: IPFLAG, I, NRMAX, NPGAS, J, N 
      CHARACTER :: XNAM*7 
      INTEGER   :: ISOFLG
!-----------------------------------------------
!
 
!  --- SET DEFAULTS TO NOT SUBSTITUTE NEW MOLECULAR MASS
      IPFLAG = 0 
      PLINE(1,:) = 0.0D0 
      PLINE(2,:) = 0.0D0 
     
      NRMAX = MOLMAX 
      NPGAS = 0 
      WRITE (16, 400) NRMAX
      READ (13, 402) NRET, ISOFLG 
      WRITE (16, 402) NRET, ISOFLG
      
      USEISO = ISOFLG .EQ. 1 
      NISOSEP=0 ! DEFAULT NUMBER OF SEPARATED ISOTOPES TO ZERO
      !  --- SEE IF WE NEED TO SEPARATE OUT ISOTOPES
      IF ( USEISO ) CALL RDISOFILE

      IF (NRET <= NRMAX) THEN 
         DO J = 1, NRET 
            WRITE (16, 600) J 
            READ (13, 500) XNAM 
            WRITE (16, 501) XNAM 
            DO I = 1, MOLTOTAL 
               IF (XNAM == NAME(I)) GO TO 176 
            END DO 
            WRITE (16, 610) 
            STOP  
  176       CONTINUE 
            IGAS(J) = I 
            WRITE (16, 601) XNAM 
            READ (13, 402) IRTYPE(J), IFOFF(J), ZWID(J), ZGMIN(J), ZGMAX(J) 
            WRITE (16, 402) IRTYPE(J) 
            IF (IRTYPE(J) == 1) THEN 
               READ (13, *) COLSF(J), SCOLSF(J) 
               WRITE (16, 401) COLSF(J), SCOLSF(J) 
               CYCLE  
            ENDIF 
            IF (IRTYPE(J) .NE. NLEV) THEN
               WRITE (16, *) "IRTYPE OF ",IRTYPE(J)," FOR GAS ",XNAM 
               WRITE (16, *) " DOES NOT MATCH PT FILE NUMBER OF LEVELS OF ",NLEV
               CLOSE(16)
               STOP
            ENDIF
            
! --- THIS WILL BE A PROFILE RETRIEVAL             
            NPGAS = NPGAS + 1 
            IF (NPGAS > MAXPRF) GO TO 301 
            N = IRTYPE(J) 
            
! --- READ IN DIAGONAL ELEMENTS OF SA OR FILENAME OF FULL COVARIANCE           
            SELECT CASE ( IFOFF(J) )
            CASE (0)    ! NO INTERLAYER CORRELATION
               WRITE (16, 613) 
               READ (13, *) (SIG(I,NPGAS),I=1,N) 
               WRITE (16, 612) (SIG(I,NPGAS),I=1,N) 
               WRITE (16, 403) 
            CASE (1)    ! GAUSSIAN ILC (ORIGINAL)
               WRITE (16, 613) 
               READ (13, *) (SIG(I,NPGAS),I=1,N) 
               WRITE (16, 612) (SIG(I,NPGAS),I=1,N) 
               WRITE (16, 614) ZWID(J), ZGMIN(J), ZGMAX(J) 
            CASE (2)    ! EXPONENTIAL ILC
               WRITE (16, 613) 
               READ (13, *) (SIG(I,NPGAS),I=1,N) 
               WRITE (16, 612) (SIG(I,NPGAS),I=1,N) 
               WRITE (16, 615) ZWID(J), ZGMIN(J), ZGMAX(J)                
            !CASE (3)    ! NOT USED
                           
            CASE (4)    ! READ IN FILE AS FULL SA ( SA.INPUT )
               !READ (13,'(A)' ) TFIL62
               WRITE (16, 617 ) N, N, TRIM( TFIL62 ) 
               READ (13, *) (SIG(I,NPGAS),I=1,N) 
               WRITE (16, 612) (SIG(I,NPGAS),I=1,N) 
               !SIG( 1:N, NPGAS ) = 0.0D0  
            CASE (5)    ! READ IN FILE AS FULL SA INVERSE (SA.INPUT )
               !STOP " FULL INVERSE NOT IMPLEMENTED YET"
               !READ (13,'(A)' ) TFIL62
               WRITE (16, 618 ) N, N, TRIM( TFIL62 ) 
               READ (13, *) (SIG(I,NPGAS),I=1,N) 
               WRITE (16, 612) (SIG(I,NPGAS),I=1,N)    
               !SIG( 1:N, NPGAS ) = 0.0D0
            CASE DEFAULT
               STOP ' PINP: FLAG IFOFF MUST BE ONE OF 0, 1, 2, 4, 5'
            END SELECT
         END DO 
         WRITE (16, 620) 
         READ (13, 406) DELNU, DN, LSHAPEMODEL
         WRITE (16, 406) DELNU, DN, LSHAPEMODEL
         WRITE (16, 650) 
 
!  --- USE IPFLAG TO DETERMINE IF MASS SUBSTITUTION LINE EXISTS
         READ (13, 212) ITRMAX, IPFLAG 
         NEGFLAG = -1
         IF( ITRMAX .LT. 0 ) THEN
         	ITRMAX = IABS(ITRMAX)
         	NEGFLAG = 0
         ENDIF
         WRITE (16, 212) ITRMAX 
         WRITE (16, 651) IPFLAG 
 
         IF (IPFLAG == 1) THEN 
            READ (13, 215) (PLINE(1,I),I=1,MAXMOLSUB) 
            READ (13, 215) (PLINE(2,I),I=1,MAXMOLSUB) 
            WRITE (16, 652) 
            WRITE (16, 215) (PLINE(1,I),I=1,MAXMOLSUB) 
            WRITE (16, 215) (PLINE(2,I),I=1,MAXMOLSUB) 
         ENDIF 
 
         RETURN  
      ENDIF 
     
      WRITE (16, 605) NRMAX 
      CLOSE(16) 
      STOP  
      
  301 CONTINUE 
      WRITE (16, 606) NPGAS, MAXPRF 
      CLOSE(16) 
      STOP  
      
  215 FORMAT(30F5.0) 
  212 FORMAT(2I5) 

  400 FORMAT(/,' INPUT NUMBER OF RETRIEVAL GASES (MAX=',I2,')', &
             /,' ISOTOPE SEPARATION FLAG (INCLUDE=1)') 
  401 FORMAT(2F10.5) 
  402 FORMAT(2I5,3E10.0)
  403 FORMAT(/,' OFF DIAGNOAL COEFFICIENTS SET TO ZERO') 
!  404 FORMAT(/,' INCLUDE OFF DIAGONAL TERMS? 0=NO, 1=YES') 
  406 FORMAT(2F10.5,I5) 
  500 FORMAT(A7) 
  501 FORMAT(1X,A7) 
  600 FORMAT(/,' NAME OF RETRIEVAL GAS #',I2) 
  601 FORMAT(/,' RETRIEVAL CODE FOR ',A7,/,&
         '       1=SCALE VERTICAL DISTRIBUTION',/,&
         '      29=PROFILE RETRIEVAL; VALUE IS # OF LAYERS') 
  605 FORMAT(' ABORT -- NUMBER OF RETRIEVAL GASES EXCEEDS',I2) 
  606 FORMAT(' ABORT -- NUMBER OF PROFILE RETRIEVALS (NPGAS=',I2,&
         ') EXCEEDS MAXIMUM (MAXPRF=',I2,')') 
  610 FORMAT(' PINP: RETRIEVAL GAS NOT IN INPUT LIST *** ABORT') 
  612 FORMAT(6F12.4) 
  613 FORMAT(' RELATIVE UNCERTAINTIES OF THE A PRIORI PROFILE') 
  614 FORMAT(' HALF WIDTH HALF HEIGHT (KM) OF GAUSSIAN INTERLAYER',&
         ' CORRELATION =',ES11.4,/,&
         ' MINIMUM ALTITUDE (KM) FOR NON-ZERO OFF-DIAGONAL =',F10.3,/,&
         ' MAXIMUM ALTITUDE (KM) FOR NON-ZERO OFF-DIAGONAL =',F10.3) 
  615 FORMAT(' HALF WIDTH HALF HEIGHT (KM) OF EXPONENTIAL INTERLAYER',&
         ' CORRELATION =',ES11.4,/,&
         ' MINIMUM ALTITUDE (KM) FOR NON-ZERO OFF-DIAGONAL =',F10.3,/,&
         ' MAXIMUM ALTITUDE (KM) FOR NON-ZERO OFF-DIAGONAL =',F10.3) 
!  616 FORMAT(' HALF WIDTH HALF HEIGHT (KM) OF FIRST DERIVATIVE INTERLAYER',&
!         ' CORRELATION =',ES11.4,/,&
!         ' MINIMUM ALTITUDE (KM) FOR NON-ZERO OFF-DIAGONAL =',F10.3,/,&
!         ' MAXIMUM ALTITUDE (KM) FOR NON-ZERO OFF-DIAGONAL =',F10.3) 
 617  FORMAT( " READING IN",I3," x",I3," COVARIANCE MATRIX FROM FILE : ", A )
 618  FORMAT( " READING IN",I3," x",I3," INVERSE COVARIANCE MATRIX FROM FILE : ", A ) 
  620 FORMAT(/,' ENTER HALF WIDTH OF INTEGRATION INTERVAL(CM-1)',/,&
         ' POINT SPACING FOR MONOCHROMATIC CALCULATIONS',/,&
         ' LINESHAPE MODEL 0-GALATRY IF B0 EXISTS, 1-VOIGT, 2-GALATRY' )
  650 FORMAT(' ENTER MAX. NO. OF ITERATIONS') 
  651 FORMAT(' MOLECULAR MASS SUBSTITUTION FLAG:',I3) 
  652 FORMAT(" MASS ID#'S AND VALUES (0-NO SUBSTITUTION):") 
      RETURN  
      END SUBROUTINE PINP 
